# -*- coding: utf-8 -*- #############################################################################################
########################################################################################################### PRE.SOF #

import pkg_resources,sys,random
from subprocess import run,PIPE,STDOUT

# GLOBAL ############################################################################################################
############################################################################################################ GLOBAL #

BRK="##################################################################################"

# RUN_CMD ###########################################################################################################
########################################################################################################### RUN_CMD #

def run_cmd(cmd):
    ps=run(cmd,stdout=PIPE,stderr=STDOUT,shell=True,text=True)
    print(ps.stdout)

# C #################################################################################################################
################################################################################################################# C #

def c(s):
    colors={'r':31,'g':32,'y':33,'b':34,'m':35,'c':36,'R':91,'G':92,'Y':93,'B':94,'M':95,'C':96}
    return f'\033[{colors[s]}m'

# RGB ###############################################################################################################
############################################################################################################### RGB #

def rgb():
    
    #################################################################################################################
    #################################################################################################################
    
    r=random.randint(0,255)
    g=random.randint(0,255)
    b=random.randint(0,255)
    
    #################################################################################################################
    #################################################################################################################    
    
    print(f"\033[38;2;{r};{g};{b}m",end="")

# NUM ###############################################################################################################
############################################################################################################### NUM #

def num(s):

        #############################################################################################################
        #############################################################################################################

        l=len(s); n=0

        #############################################################################################################
        #############################################################################################################

        while n<l+3:
            print("#",end=""); n+=1
            
        #############################################################################################################
        #############################################################################################################

# NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM NUM

# LOG ###############################################################################################################
################################################################################################################# LOG

def log(s,ss,n):

        #############################################################################################################
        #############################################################################################################

        TXT=f"{s} - {ss}"

        #############################################################################################################
        #############################################################################################################
        
        if n==0: msg(s=f"{num(TXT)}![ {TXT} ]!{num(TXT)}",n=0,ss="")
        elif n==1: msg(s=f"+ SUCCESS > {TXT}",n=0,ss="")
        elif n==2: msg(s=f"- FAILURE > {TXT}",n=0,ss="")
        elif n==3: msg(s=f"{num(ss)}!# {ss} #!{num(ss)}!",n=0,ss="")
        elif n==4: msg(s=f"> {TXT}",n=0,ss="")
        elif n==5: msg(s=f"> MAPLE > {s}",n=0,ss="")
        elif n==6: msg(s=f"{s} - {ss}",n=0,ss="")
        elif n==7: 
            r=msg(s=f"{s}",n=1,ss="")
            return r

        
        #############################################################################################################
        #############################################################################################################

# LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG LOG

# MSG ###############################################################################################################
################################################################################################################# MSG

def msg(s,n=0,ss=""):

        #############################################################################################################
        #############################################################################################################
        
        for _ in s:
            if _=="!":
                if n==0:
                    print("".replace("None",""))
                else:
                    ss=f"{ss}\n".replace("None","")
            else:
                if n==0:
                    print(f"{rgb()}{_}".replace("None",""),end="")
                else:
                    ss=f"{ss}{rgb()}{_}".replace("None","")
        if n==0:
            print("".replace("None",""))
        else:
            return ss
        #############################################################################################################
        #############################################################################################################

# MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG MSG

#####################################################################################################################
#####################################################################################################################

modules={"asyncio","scikit-learn","numpy","requests","torch","tqdm","transformers==2.3.0"}
installed={pkg.key for pkg in pkg_resources.working_set}
missing=modules-installed

#####################################################################################################################
#####################################################################################################################

if missing:
    
    #################################################################################################################
    #################################################################################################################

    log("SHELLED","UPGRADING PYTHON MODULE: PIP",4)
    msg(f"!{BRK}!")
    run_cmd(f'{sys.executable} -um pip install --upgrade pip')
    
    #################################################################################################################
    #################################################################################################################

    for missing_module in missing:
        if not missing_module=="transformers==2.3.0":
            msg(f"{BRK}!")
            log("SHELLED",f"INSTALLING MISSING PYTHON MODULE: {str(missing_module).upper()}",4)
            msg(f"!{BRK}!")
            run_cmd(f'{sys.executable} -um pip install {missing_module}')
            if missing_module=='asyncio':
                exec(f'import {missing_module}')
            elif missing_module=="sklearn":
                import sklearn
            elif missing_module=="numpy":
                import numpy as np
            elif missing_module=="requests":
                exec(f'import {missing_module}')
            elif missing_module=="torch":
                exec(f'import {missing_module}')
                import torch.nn.functional as F
            elif missing_module=="tqdm":
                from tqdm import tqdm
    
    #################################################################################################################
    #################################################################################################################

    if "transformers==2.3.0" in missing:
        missing_module="transformers==2.3.0"
        msg(f"{BRK}!")
        log("SHELLED",f"INSTALLING MISSING PYTHON MODULE: {str(missing_module).upper()}",4)
        msg(f"!{BRK}!")
        run_cmd(f'{sys.executable} -um pip install {missing_module}')
        from transformers import GPT2Config, GPT2LMHeadModel, GPT2Tokenizer
    
#####################################################################################################################
#####################################################################################################################

if not missing:
    import asyncio
    import sklearn
    import numpy as np
    import requests
    import torch
    import torch.nn.functional as F
    from tqdm import tqdm
    from transformers import GPT2Config, GPT2LMHeadModel, GPT2Tokenizer
            
# PRE.EOF ###########################################################################################################
########################################################################################################### PRE.EOF #

import os,io,logging,configparser
from glob import glob
from time import time
from datetime import datetime
from difflib import SequenceMatcher

#####################################################################################################################
#####################################################################################################################

global message_history
class MESSAGE_HISTORY():

    # CLASS - MESSAGE_HISTORY - EOP #################################################################################
    ################################################################################# CLASS - MESSAGE_HISTORY - EOP #

    maple_messages = []
    user_messages = []
    user_users = []
    last_message = ''
    maple_message = ''

    # MESSAGE_HISTORY.__INIT__ ######################################################################################
    ######################################################################################## MESSAGE_HISTORY._INIT_ #

    def __init__(self):
    
        #############################################################################################################
        #############################################################################################################        
    
        self.processing=0
        self.bounce=False
        self.loopcount=0

    # PUSH_MAPLE_MESSAGES ###########################################################################################
    ########################################################################################### PUSH_MAPLE_MESSAGES #

    def push_maple_messages(self,data):
    
        #############################################################################################################
        #############################################################################################################        
    
        self.maple_messages = self.maple_messages[-1:] + self.maple_messages[:-1]
        self.maple_messages[0] = data

    # PUSH_USER_MESSAGES ############################################################################################
    ############################################################################################ PUSH_USER_MESSAGES #

    def push_user_messages(self,user,data):
    
        #############################################################################################################
        #############################################################################################################        
    
        self.user_users.append(user)
        self.user_messages.append(data)

    # SIMILAR #######################################################################################################
    ####################################################################################################### SIMILAR #

    def similar(self,a,b):
    
        #############################################################################################################
        #############################################################################################################        
    
        return SequenceMatcher(None,a,b).ratio()

# CLASS - MAPLE #####################################################################################################
##################################################################################################### CLASS - MAPLE #

class MAPLE:

    # CLASS - MAPLE - EOP ###########################################################################################
    ########################################################################################### CLASS - MAPLE - EOP #

    terminate=False
    logging.basicConfig(format='%(asctime)s - %(name)s - %(levelname)s - %(message)s', level=logging.INFO)
    logger=logging.getLogger(__name__)

    #################################################################################################################
    #################################################################################################################

    CONFIG_FILE={

        #############################################################################################################
        #############################################################################################################
    
        'small':'https://convaisharables.blob.core.windows.net/lsp/117M/config.json',
        'medium':'https://convaisharables.blob.core.windows.net/lsp/345M/config.json'
    }

    #################################################################################################################
    #################################################################################################################

    VOCAB_FILE={

        #############################################################################################################
        #############################################################################################################
    
        'small':'https://convaisharables.blob.core.windows.net/lsp/117M/vocab.json',
        'medium':'https://convaisharables.blob.core.windows.net/lsp/345M/vocab.json'
    }

    #################################################################################################################
    #################################################################################################################

    MERGE_FILE={

        #############################################################################################################
        #############################################################################################################
    
        'small':'https://convaisharables.blob.core.windows.net/lsp/117M/merges.txt',
        'medium':'https://convaisharables.blob.core.windows.net/lsp/345M/merges.txt'
    }

    #################################################################################################################
    #################################################################################################################

    LSP_MODEL_URL={

        #############################################################################################################
        #############################################################################################################
    
        'multiref':{
            'medium_fs':'https://convaisharables.blob.core.windows.net/lsp/multiref/medium_fs.pkl',
            'medium_ft':'https://convaisharables.blob.core.windows.net/lsp/multiref/medium_ft.pkl',
            'small_fs':'https://convaisharables.blob.core.windows.net/lsp/multiref/small_fs.pkl',
            'small_ft':'https://convaisharables.blob.core.windows.net/lsp/multiref/small_ft.pkl'
        },

        #############################################################################################################
        #############################################################################################################
    
        'dstc':{
            'small_ft':'https://convaisharables.blob.core.windows.net/lsp/DSTC/medium_ft.pkl'
        }
    }

    #################################################################################################################
    #################################################################################################################

    REVERSE_MODEL_URL='https://convaisharables.blob.core.windows.net/lsp/multiref/small_reverse.pkl'

    #################################################################################################################
    #################################################################################################################

    OPINION="""
    """
    #################################################################################################################
    #################################################################################################################

    WISDOM="""
    """

    #################################################################################################################
    #################################################################################################################

    PERSONALITY="""
    [model]
    data_folder=models
    model_size=medium
    dataset=multiref
    from_scratch=True
    no_cuda=False
    use_mmi=False
    [decoder]
    seed=0
    temperature=0.6474
    top_k=40
    top_p=0
    max_length=1024
    num_samples=1
    max_turns_history=-1
    """

    # MAPLE.__INIT__ ################################################################################################
    ################################################################################################ MAPLE.__INIT__ #

    def __init__(self):
    
        #############################################################################################################
        #############################################################################################################        
    
        log("PROGRAM",f"[ CLASS LOADED: MAPLE ]",4)
        self.data=""
        self.history=MESSAGE_HISTORY()
        message_history=self.history
        for _ in range(5): self.history.maple_messages.append("")
        self.mode=0
        self.span=0
        self.epoch_time_last=0
        self.epoch_time_now=0
        self.epoch_time_boolean=False
        self.maple_io=[]
        self.PERSONALITY=self.PERSONALITY.format(RND=datetime.now().microsecond)
        self.delay=0.05
        CONFIG=io.StringIO(self.PERSONALITY)
        self.config=configparser.ConfigParser()
        self.config.read_file(CONFIG)
        self.target_folder_name=self.download_model_folder(self.config)
        self.model,self.tokenizer=self.load_model(self.target_folder_name,self.config)
        self.use_mmi=self.config.getboolean('model','use_mmi')
        if self.use_mmi:
            self.mmi_target_folder_name=self.download_reverse_model_folder(self.config)
            self.mmi_model,mmi_tokenizer=self.load_model(self.mmi_target_folder_name,self.config)
        else:
            self.mmi_model=None
            self.mmi_tokenizer=None

    # HTTP_GET ######################################################################################################
    ###################################################################################################### HTTP_GET #

    def http_get(self,url,temp_file):
    
        #############################################################################################################
        #############################################################################################################        
    
        req=requests.get(url,stream=True)
        content_length=req.headers.get('Content-Length')
        total=int(content_length) if content_length is not None else None
        progress=tqdm(unit="B",total=total)
        for chunk in req.iter_content(chunk_size=1024):
            if chunk:
                progress.update(len(chunk))
                temp_file.write(chunk)


    # DOWNLOAD_FILE #################################################################################################
    ################################################################################################# DOWNLOAD_FILE #

    def download_file(self,url,folder):
    
        #############################################################################################################
        #############################################################################################################        
            
        if not os.path.exists(folder):
            os.makedirs(folder,exist_ok=True)
        file_name=os.path.basename(url)
        if 'pytorch_model.bin' in file_name:
            file_name='pytorch_model.bin'
        if os.path.isfile(os.path.join(folder,file_name)):
            return
        with open(os.path.join(folder,file_name),'wb') as f:
            self.http_get(url,f)

    # DOWNLOAD_MODEL_FOLDER #########################################################################################
    ######################################################################################### DOWNLOAD_MODEL_FOLDER #

    def download_model_folder(self,config):
    
        #############################################################################################################
        #############################################################################################################        
    
        data_folder=config.get('model','data_folder')
        model_size=config.get('model','model_size')
        dataset=config.get('model','dataset')
        from_scratch=config.getboolean('model','from_scratch')
        if not os.path.exists(data_folder):
            os.makedirs(data_folder, exist_ok=True)
        target_folder_name=model_size+"_"+dataset+("_fs" if from_scratch else "_ft")
        target_folder=os.path.join(data_folder,target_folder_name)
        log("PROGRAM",f"[ DOWNLOADING MODEL FILES ] - PATH: {target_folder_name}",4)
        self.download_file(self.CONFIG_FILE[model_size],target_folder)
        self.download_file(self.VOCAB_FILE[model_size],target_folder)
        self.download_file(self.MERGE_FILE[model_size],target_folder)
        model_train_type=model_size+('_fs' if from_scratch else '_ft')
        if model_train_type not in self.LSP_MODEL_URL[dataset]:
            k=','.join(list(self.LSP_MODEL_URL[dataset].keys()))
            raise ValueError(f"'{model_train_type}' not exist for dataset '{dataset}', please choose from [{k}]")
        self.download_file(self.LSP_MODEL_URL[dataset][model_train_type],target_folder)
        return target_folder_name

    # DOWNLOAD_REVERSE_MODEL ########################################################################################
    ######################################################################################## DOWNLOAD_REVERSE_MODEL #

    def download_reverse_model_folder(self,config):
    
        #############################################################################################################
        #############################################################################################################        
        
        data_folder=config.get('model','data_folder')
        model_size='medium'
        if not os.path.exists(data_folder):
            os.makedirs(data_folder,exist_ok=True)
        target_folder_name=model_size+'_reverse'
        target_folder=os.path.join(data_folder,target_folder_name)
        log("PROGRAM",f"[ DOWNLOADING MODEL FILES ] - PATH: {target_folder_name}",4)        
        self.download_file(self.CONFIG_FILE[model_size],target_folder)
        self.download_file(self.VOCAB_FILE[model_size],target_folder)
        self.download_file(self.MERGE_FILE[model_size],target_folder)
        self.download_file(self.REVERSE_MODEL_URL,target_folder)
        return target_folder_name
        
    # LOAD_MODEL ####################################################################################################
    #################################################################################################### LOAD_MODEL #

    def load_model(self,target_folder_name,config):
    
        #############################################################################################################
        #############################################################################################################        
    
        data_folder=config.get('model','data_folder')
        model_size=config.get('model','model_size')
        no_cuda=config.getboolean('model', 'no_cuda')
        log("PROGRAM",f"[ DOWNLOADING MODEL FILES ] - PATH: {target_folder_name}",4)                
        print(f'[ downloading model files ] - path: {target_folder_name}')
        device=torch.device("cuda" if torch.cuda.is_available() and not no_cuda else "cpu")
        target_folder=os.path.join(data_folder,target_folder_name)
        tokenizer=GPT2Tokenizer(os.path.join(target_folder, 'vocab.json'), os.path.join(target_folder,'merges.txt'))
        config=GPT2Config.from_json_file(os.path.join(target_folder,'config.json'))
        state_dict_path=glob(os.path.join(target_folder,f'*.pkl'))[0]
        state_dict=torch.load(state_dict_path,map_location=device)
        if model_size=='small':
            for key in list(state_dict.keys()):
                state_dict[key.replace('module.','')]=state_dict.pop(key)
        state_dict['lm_head.weight']=state_dict['lm_head.decoder.weight']
        state_dict.pop("lm_head.decoder.weight",None)
        model=GPT2LMHeadModel(config)
        model.load_state_dict(state_dict)
        model.to(device)
        model.eval()
        return model,tokenizer
        
    # SET_SEED ######################################################################################################
    ###################################################################################################### SET_SEED #

    def set_seed(self,seed):
    
        #############################################################################################################
        #############################################################################################################        
    
        random.seed(seed)
        np.random.seed(seed)
        torch.manual_seed(seed)

    # TOP_K_TOP_P_FILTERING #########################################################################################
    ######################################################################################### TOP_K_TOP_P_FILTERING #

    def top_k_top_p_filtering(self,logits,top_k=0,top_p=0.0,filter_value=-float('Inf')):
    
        #############################################################################################################
        #############################################################################################################        
    
        top_k=min(top_k,logits.size(-1))
        if top_k>0:
            indices_to_remove=logits<torch.topk(logits,top_k)[0][...,-1,None]
            logits[indices_to_remove]=filter_value
        if top_p>0.0:
            sorted_logits,sorted_indices=torch.sort(logits,descending=True)
            cumulative_probs=torch.cumsum(F.softmax(sorted_logits,dim=-1),dim=-1)
            sorted_indices_to_remove=cumulative_probs>top_p
            sorted_indices_to_remove[...,1:]=sorted_indices_to_remove[...,:-1].clone()
            sorted_indices_to_remove[...,0]=0
            indices_to_remove=sorted_indices_to_remove.scatter(dim=1,index=sorted_indices,src=sorted_indices_to_remove)
            logits[indices_to_remove]=filter_value
        return logits

    # SAMPLE_SEQUENCE ###############################################################################################
    ############################################################################################### SAMPLE_SEQUENCE #

    def sample_sequence(self,model,tokenizer,context_ids,config):
    
        #############################################################################################################
        #############################################################################################################        
    
        no_cuda=config.getboolean('model','no_cuda')
        num_samples=config.getint('decoder','num_samples')
        max_length=config.getint('decoder','max_length')
        temperature=config.getfloat('decoder','temperature')
        top_k=config.getint('decoder','top_k')
        top_p=config.getfloat('decoder','top_p')
        device=torch.device("cuda" if torch.cuda.is_available() and not no_cuda else "cpu")
        context_tensor=torch.tensor(context_ids,dtype=torch.long,device=device)
        context_tensor=context_tensor.unsqueeze(0).repeat(num_samples,1)
        generated=context_tensor
        with torch.no_grad():
            while True:
                inputs={'input_ids':generated}
                outputs=model(**inputs)
                next_token_logits=outputs[0][:,-1,:]/(temperature if temperature>0 else 1.)
                filtered_logits=self.top_k_top_p_filtering(next_token_logits,top_k=top_k,top_p=top_p)
                if temperature==0.0:
                    next_token=torch.argmax(filtered_logits,dim=-1).unsqueeze(-1)
                else:
                    next_token=torch.multinomial(F.softmax(filtered_logits,dim=-1),num_samples=1)
                generated=torch.cat((generated,next_token),dim=1)
                if (generated[:,len(context_ids):]==tokenizer.eos_token_id).any(dim=1).all():
                    break
                if generated.shape[1]-len(context_ids)>=max_length:
                    break
        return generated

    # SELECT_USING_MMI ##############################################################################################
    ############################################################################################## SELECT_USING_MMI #

    def select_using_mmi(self,mmi_model,mmi_tokenizer,candidates,config):
    
        #############################################################################################################
        #############################################################################################################        
    
        no_cuda=config.getboolean('model','no_cuda')
        device=torch.device("cuda" if torch.cuda.is_available() and not no_cuda else "cpu")
        scores=[]
        for i,candidate in enumerate(candidates):
            context=[]
            for response in reversed(candidate):
                context.extend(response)
                context.append(mmi_tokenizer.eos_token_id)
            context_ids=mmi_tokenizer.encode(context)
            context_tensor=torch.tensor(context_ids,dtype=torch.long,device=device)
            loss,_,_=mmi_model(input_ids=context_tensor,labels=context_tensor)
            scores.append(-loss.float())
        scores=torch.stack(scores, dim=0)
        winner=torch.multinomial(F.softmax(scores,dim=0),num_samples=1).item()
        return winner

    # GENERATE RESPONSE #############################################################################################
    ############################################################################################# GENERATE RESPONSE #

    def generate_response(self,model,tokenizer,context,config,mmi_model=None,mmi_tokenizer=None):
    
        #############################################################################################################
        #############################################################################################################        
    
        use_mmi=config.getboolean('model','use_mmi')
        num_samples=config.getint('decoder','num_samples')
        max_length=config.getint('decoder','max_length')
        seed=config.get('decoder','seed')
        seed=int(seed) if seed is not None else None
        if seed is not None:
            self.set_seed(seed)
        context_ids=tokenizer.encode(context)
        samples=self.sample_sequence(model, tokenizer, context_ids, config)
        samples=samples[:, len(context_ids):].tolist()
        texts=[]
        for sample in samples:
            text=tokenizer.decode(sample,clean_up_tokenization_spaces=True)
            text=text[: text.find(tokenizer.eos_token)]
            texts.append(text)
        if use_mmi:
            assert(num_samples > 1)
            candidates=[context+text for text in texts]
            best_i=self.select_using_mmi(mmi_model,mmi_tokenizer,candidates,config)
            return [texts[best_i]]
        return texts

    # RUN_CHAT ######################################################################################################
    ###################################################################################################### RUN_CHAT #

    def run_chat(self,model,tokenizer,config,mmi_model=None,mmi_tokenizer=None):
    
        #############################################################################################################
        #############################################################################################################        
    
        num_samples=config.getint('decoder','num_samples')
        max_turns_history=config.getint('decoder','max_turns_history')
        turns=[]
        #signal.signal(signal.SIGINT,self.signal_handling)
        config.set('decoder','seed',f'{datetime.now().microsecond}')
        try:
            if not type(self.bot.history.bounce)==bool:
                print(f'[ received bounce message ]')
                USER=self.bot.history.bounce['user']
                MESSAGE=self.bot.history.bounce['message']
                TARGET=self.bot.history.bounce['target']
                self.maple_io.append({'user':USER,'message':MESSAGE,'target':TARGET})
                self.bot.history.bounce=False
        except:
            pass
        try:
            self.maple_io.reverse()
            maple_io=self.maple_io.pop()
            self.maple_io.reverse()
            USER=maple_io['user']
            MESSAGE=maple_io['message'].strip()
            TARGET=maple_io['target']
        except:
            return True
        log(f"[ HUMAN > {MESSAGE} ]",f"{TARGET.upper()} {USER.upper()}",6)
        self.history.maple_message=MESSAGE
        if max_turns_history==0:
            turns=[]
        turn={
            'human_messages':[],
            'maple_messages':[]
        }
        turns.append(turn)
        turn['human_messages'].append(f'{USER} {MESSAGE}')
        history=""
        from_index=max(len(turns)-max_turns_history-1,0) if max_turns_history>=0 else 0
        WISDOM=self.WISDOM.splitlines()
        try:
            WISDOM.remove('')
        except:
            pass
        for i,_ in enumerate(WISDOM):
            WISDOM[i]=_.strip()
        static_history=WISDOM

        for message in static_history:
            history += message + tokenizer.eos_token
        for turn in turns[from_index:]:
            for message in turn['human_messages']:
                history+=message+tokenizer.eos_token
            for message in turn['maple_messages']:
                history+=message+tokenizer.eos_token
        maple_messages=self.generate_response(
            model,
            tokenizer,
            history,
            config,
            mmi_model=mmi_model,
            mmi_tokenizer=mmi_tokenizer
        )
        
        #############################################################################################################
        #############################################################################################################
        
        if num_samples==1:
            maple_message=maple_messages[0]
        else:
            maple_message=random.choice(maple_messages)
        turn['maple_messages'].append(maple_message)

        ########################################################################################### REPROCESSOR SOF #
        # SIMILARITY ################################################################################################

        for i in range(len(self.history.maple_messages)):
            if self.history.similar(maple_message,str(self.history.maple_messages[i]))>0.9:
                self.maple_io.append({'user':USER,'message':f'{MESSAGE}','target':TARGET})
                log("MAPLE LOGIC REJECTION",f"[ SIMILARITY ] - REPEAT OF PREVIOUS RESPONSE",2)
                self.history.loopcount+=1
                return False

        ############################################################################################### MOCK / DUPE #
        # MOCK / DUPE ###############################################################################################

        if self.history.similar(maple_message,MESSAGE)>0.9:
            self.maple_io.append({'user':USER,'message':f'{MESSAGE}','target':TARGET})
            log("MAPLE LOGIC REJECTION",f"[ HUMAN MOCK ] - RESPONSE SAME AS HUMAN INPUT",2)
            self.history.loopcount+=1
            return False

        ########################################################################################### GPT LOOP GLITCH #
        # GPT LOOP GLITCH ###########################################################################################

        n=len(maple_message.split())
        i=len(set(maple_message.split()))
        if i<int(n/2):
            self.maple_io.append({'user':USER,'message':f'{MESSAGE}','target':TARGET})
            log("MAPLE LOGIC REJECTION",f"[ LOOP ] - REITERATING THE SAME THING IN MULTIPLES",2)
            self.history.loopcount+=1
            return False

        ########################################################################################## LIMITED RESPONSE #
        # LIMITED RESPONSE ##########################################################################################

        n=len(maple_message.split())
        if i<3:
            self.maple_io.append({'user':USER,'message':f'{MESSAGE}','target':TARGET})
            log("MAPLE LOGIC REJECTION",f"[ LIMITED RESPONSE ] - SKIP AN UNFINISHED TOKEN CHAIN",2)
            self.history.loopcount+=1
            return False
        self.history.push_maple_messages(maple_message)
        log(maple_message,"",5)
        MAPLE_MESSAGE=maple_message.replace('lt 3','<3')
        msg=f'{MAPLE_MESSAGE}'
        self.history.loopcount=0
        return True

    # CLASS - MAPLE.MAIN ############################################################################################
    ############################################################################################ CLASS - MAPLE.MAIN #

    def main(self):
    
        #############################################################################################################
        #############################################################################################################
        
        FLAG_OK=False
        while not FLAG_OK:
            FLAG_OK=self.run_chat(self.model,self.tokenizer,self.config,mmi_model=self.mmi_model,mmi_tokenizer=self.mmi_tokenizer)
            if self.history.loopcount>25:
                self.history.loopcount=0
                self.maple_io=[]
                FLAG_OK=True
        
# __MAIN__ ##########################################################################################################
########################################################################################################## __MAIN__ #

if __name__ == "__main__":

    #################################################################################################################
    #################################################################################################################
        
    maple=MAPLE()
    FLAG_OK=False
    while not FLAG_OK:
        maple.data=""
        while len(maple.data) <= 1:
            r=log("< HUMAN: ","",7)
            print(r,end="")
            maple.data=input()
        maple.history.last_message=maple.data
        maple.span=0
        for _ in maple.data.split():
            for __ in maple.OPINION.split():
                if _ == __:
                    maple.span=1
                    break
        maple.span=0
        maple.maple_io.append({'user':"user",'message':f'{maple.data}','target':"local"})
        maple.main()

#####################################################################################################################
############################################################################################################### EOF #
